package com.cirmuller.maidaddition.entity.sensor;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.cirmuller.maidaddition.configs.Config;
import com.cirmuller.maidaddition.entity.memory.CraftingAndCarryingMemory;
import com.cirmuller.maidaddition.entity.memory.MemoryRegistry;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import com.github.tartaricacid.touhoulittlemaid.inventory.handler.BaubleItemHandler;
import com.simibubi.create.AllBlocks;
import java.util.Set;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.world.entity.ai.sensing.Sensor;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.items.wrapper.EntityHandsInvWrapper;
import studio.fantasyit.maid_storage_manager.items.StorageDefineBauble;
import studio.fantasyit.maid_storage_manager.registry.ItemRegistry;

public class CraftingAndCarryingSensor extends Sensor<EntityMaid> {
  private static final int scanRate = ((Integer)Config.UPDATE_RATE.get()).intValue();
  
  public CraftingAndCarryingSensor() {
    super(scanRate);
  }
  
  protected void doTick(ServerLevel serverLevel, EntityMaid maid) {
    BaubleItemHandler baubles = maid.getMaidBauble();
    CraftingAndCarryingMemory memory = maid.m_6274_().m_21952_((MemoryModuleType)MemoryRegistry.CRAFTING_AND_CARRYING_MEMORY.get()).orElse(null);
    if (memory == null) {
      memory = new CraftingAndCarryingMemory(maid);
      maid.m_6274_().m_21879_((MemoryModuleType)MemoryRegistry.CRAFTING_AND_CARRYING_MEMORY.get(), memory);
    } 
    for (int i = 0; i < baubles.getSlots(); i++) {
      ItemStack stack = baubles.getStackInSlot(i);
      if (stack.m_41720_().equals(ItemRegistry.STORAGE_DEFINE_BAUBLE.get()))
        switch (null.$SwitchMap$studio$fantasyit$maid_storage_manager$items$StorageDefineBauble$Mode[StorageDefineBauble.getMode(stack).ordinal()]) {
          case 1:
            memory.setStorageDefineBaubleFrom(stack.m_41777_());
            break;
          case 2:
            memory.setStorageDefineBaubleTo(stack.m_41777_());
            break;
        }  
    } 
    EntityHandsInvWrapper wrapper = maid.getHandsInvWrapper();
    ItemStack clipboard = wrapper.getStackInSlot(0);
    if (clipboard.m_41720_().equals(AllBlocks.CLIPBOARD.m_5456_()))
      memory.setClipboard(clipboard.m_41777_()); 
  }
  
  public Set<MemoryModuleType<?>> m_7163_() {
    return Set.of((MemoryModuleType)MemoryRegistry.CRAFTING_AND_CARRYING_MEMORY.get());
  }
}
